function aggiornaPages() {
    var jsonurl = weburl + "wp-json/wp/v2/pages/";
    $.ajax({
        dataType: "json"
        , url: jsonurl
        , success: function (data) {
            $.each(data, function (key, val) {
                var id = val.id;
                var time = val.modified;
                var title = val.title.rendered;
                var content = val.content.rendered;
                FONTE.dbHandler.executeSql('INSERT INTO xm24_pages VALUES (?,?,?,?)', [id, title, time, content], function (resultSet) {
                    console.log('resultSet.insertId: ' + resultSet.insertId);
                    console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
                }, function (error) {
                    console.log('INSERT error: ' + error.message);
                });
            });
        }
        , error: JSONErrorHandler
    });
};

function aggiornaSingleCategory(category) {
    //resetta la variabile d'errore per le chiamate ajax asincrone
    FONTE.ajaxError = false;

    var jsonurl = weburl + "wp-json/wp/v2/posts?per_page=100";

    var storage = window.localStorage;
    var lastUpdate = storage.getItem('db_update_date');

    if (lastUpdate) jsonurl += "&filter[date_query][column]=post_modified_gmt&filter[date_query][after]=" + lastUpdate;
    getSinglePageRecur(jsonurl, category, 1)
};

function aggiornaTagsToPosts(id, tagId) {
    FONTE.dbHandler.executeSql('INSERT INTO xm24_tags_to_posts VALUES (?,?)', [id, tagId], function (resultSet) {
        console.log('resultSet.insertId: ' + resultSet.insertId);
        console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
    }, function (error) {
        console.log('INSERT error: ' + error.message);
        //feedback
        $("#aggiorna").attr("src", "./image/aggiorna.png");
    });
}

function aggiornaTags(pagenum) {
    var jsonurl = weburl + "wp-json/wp/v2/tags?per_page=100&page=" + pagenum;
    $.ajax({
        dataType: "json"
        , url: jsonurl
        , success: function (data, status, xhr) {
            var totalPages = parseInt(xhr.getResponseHeader("X-WP-TotalPages"));
            $.each(data, function (key, val) {
                var name = val.name;
                var slug = val.slug;
                var id = val.id;
                var blob = JSON.stringify(val);
                FONTE.dbHandler.executeSql('INSERT INTO xm24_tags VALUES (?,?,?)', [id, slug, blob], function (resultSet) {
                    console.log('resultSet.insertId: ' + resultSet.insertId);
                    console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
                }, function (error) {
                    console.log('INSERT error: ' + error.message);
                });
            });
            pagenum += 1
            if (pagenum <= totalPages) aggiornaTags(pagenum)
        }
        , error: JSONErrorHandler
    });
};

function aggiornaora() {
    $("#aggiornaora").popup("open");
};

function resetAndUpdate() {
    var storage = window.localStorage;
    //resetto la data e droppo le tabelle
    storage.setItem('db_update_date', null);
    FONTE.dbHandler.executeSql('DROP TABLE IF EXISTS xm24_posts;');
    FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_posts (id INTEGER PRIMARY KEY, title, date, category, post)');
    partialUpdate();
}

function update() {
    FONTE.dbHandler.executeSql('SELECT COUNT(*) AS numPosts FROM xm24_posts', [], function (resultSet) {
        var numPosts = resultSet.rows.item(0).numPosts;
        if (numPosts < 300) { //questo numero e' scelto in maniera arbitraria, ricordati Cri.
            resetAndUpdate()
        } else {
            partialUpdate();
        }
    });
}

function partialUpdate() {
    //feedback
    $("#aggiorna").attr("src", "./image/icona_aggiorna.gif");
    var storage = window.localStorage;
    var jsonurl = weburl + "wp-json/wp/v2/posts?per_page=100&categories=";

    FONTE.updatedCategoriesCount = 0;
    FONTE.updatedPostsCount = 0;
    FONTE.neededPostsCount = 0;
    for (var index in FONTE.categoriesList) {
        aggiornaSingleCategory(FONTE.categoriesList[index])
    }
    FONTE.dbHandler.executeSql('DROP TABLE IF EXISTS xm24_tags;');
    //    FONTE.dbHandler.executeSql('DROP TABLE IF EXISTS xm24_tags_to_posts;');
    FONTE.dbHandler.executeSql('DROP TABLE IF EXISTS xm24_pages;');
    FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_tags (id INTEGER PRIMARY KEY, title, tag)');
    //    FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_tags_to_posts (id, tagid)');
    FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_pages (id INTEGER PRIMARY KEY, title, date, page)');
    aggiornaTags(1);
    aggiornaPages();

    var firstTime = storage.getItem('db_lastnews_firsttime');
    if (firstTime == null) storage.setItem('db_lastnews_firsttime', 'yes');
    if (firstTime == 'yes') storage.setItem('db_lastnews_firsttime', 'no');
    $("#benvenuta").popup("close");
    checkloader();

};

/*
 * data ultimo aggiornamento
 */
function ultimoAggiornamento() {
    var lastUpdate = window.localStorage.getItem('db_update_date');
    if (lastUpdate) {
        var data = lastUpdate.split('T');
        var datagiorno = data[0];
        var dataora = data[1];
        $("#datadiritti").empty();
        $("#datadirittiora").empty();
        display_results("#datadiritti", datagiorno)
        display_results("#datadirittiora", dataora)
        if (data) {
            $("#boxdata").css("display", "block");
        }
    } else {
        toastr.warning('Warn: manca la data del tuo ultimo aggiornamento. Aggiorna al più presto.');
    }
};
